package hellocucumber;

import io.cucumber.datatable.DataTable;
import io.cucumber.java.en.Given;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;

import java.util.List;
import java.util.Map;

import static org.junit.Assert.assertEquals;

public class BookStoreStepDefinitions {

    private BookStore bookStore = new BookStore();
    private List<Book> bookList;

    @Given("I have the following books in the store")
    public void i_have_the_following_books_in_the_store(DataTable data) {
        // Write code here that turns the phrase above into concrete actions
        // For automatic transformation, change DataTable to one of
        // E, List<E>, List<List<E>>, List<Map<K,V>>, Map<K,V> or
        // Map<K, List<V>>. E,K,V must be a String, Integer, Float,
        // Double, Byte, Short, Long, BigInteger or BigDecimal.
        //
        // For other transformations you can register a DataTableType.
        List<Map<String, String>> dataTableRows = data.asMaps(String.class, String.class);
        for(Map<String, String> cols : dataTableRows) {
            bookStore.addBook(new Book(cols.get("title"), cols.get("author")));
        }
    }

    @When("I search for books by author JK Rowling")
    public void i_search_for_books_by_author_jk_rowling() {
        // Write code here that turns the phrase above into concrete actions
        bookList = bookStore.getBooksByAuthor("JK Rowling");
    }

    @Then("I find {int} books")
    public void i_find_books(int int1) {
        // Write code here that turns the phrase above into concrete actions
        assertEquals(int1, bookList.size());
    }



}
